DCMTK: DiMonoPixelTemplate< T > Class Template Reference

DCMTK Version 3.6.9 OFFIS DICOM Toolkit

Loading...
Searching...
No Matches
Public Member Functions | Protected Member Functions | Protected Attributes | Private Attributes | List of all members
DiMonoPixelTemplate< T > Class Template Reference

Template class to handle monochrome pixel data. More...

Inheritance diagram for DiMonoPixelTemplate< T >:

## Public Member Functions
| DiMonoPixelTemplate (const unsigned long count)
| constructor
| DiMonoPixelTemplate (const DiInputPixel *pixel, DiMonoModality *modality)
| constructor
| DiMonoPixelTemplate (DiMonoOutputPixel *pixel, DiMonoModality *modality)
| constructor
virtual | ~DiMonoPixelTemplate ()
| destructor
EP_Representation | getRepresentation () const
| get integer representation
const void * | getData () const
| get pointer to internal pixel data
void * | getDataPtr ()
| get pointer to internal pixel data
void * | getDataArrayPtr ()
| get reference to pointer to internal pixel data.
int | getMinMaxValues (double &min, double &max) const
| get minimum and maximum pixel values
int | getMinMaxWindow (const int idx, double &center, double &width)
| get automatically computed min-max window
virtual int | getRoiWindow (const unsigned long left_pos, const unsigned long top_pos, const unsigned long width, const unsigned long height, const unsigned long columns, const unsigned long rows, const unsigned long frame, double &voiCenter, double &voiWidth)
| get automatically computed Region of Interest (ROI) window
int | getHistogramWindow (const double thresh, double &center, double &width)
| get automatically computed histogram window
Public Member Functions inherited from DiMonoPixel
| DiMonoPixel (const unsigned long count)
| constructor
| DiMonoPixel (const DiInputPixel *pixel, DiMonoModality *modality)
| constructor
| DiMonoPixel (DiMonoOutputPixel *pixel, DiMonoModality *modality)
| constructor
virtual | ~DiMonoPixel ()
| destructor
int | getPlanes () const
| get number of planes
unsigned int | getBits () const
| get number of bits per pixel
double | getAbsMinimum () const
| get absolute minimum pixel value.
double | getAbsMaximum () const
| get absolute maximum pixel value.
double | getAbsMaxRange () const
| get absolute pixel range
const char * | getModalityLutExplanation () const
| get modality LUT explanation string
DiMonoModality * | addReferenceToModality ()
| add a reference to the internally managed modality transform object
int | isPotentiallySigned () const
| check whether pixel data is 'potentially' signed.
Public Member Functions inherited from DiPixel
| DiPixel (const unsigned long count, const unsigned long inputCount=0)
| constructor
virtual | ~DiPixel ()
| destructor
unsigned long | getCount () const
| get number of pixels
unsigned long | getInputCount () const
| get number of pixels stored in the 'PixelData' element
Public Member Functions inherited from DiPixelRepresentationTemplate< T >
| DiPixelRepresentationTemplate ()
| default constructor
virtual | ~DiPixelRepresentationTemplate ()
| destructor
int | isSigned () const
| check whether template type T is signed or not

## Protected Member Functions
| DiMonoPixelTemplate (const DiPixel *pixel, DiMonoModality *modality)
| constructor
| DiMonoPixelTemplate (const DiMonoPixel *pixel, const unsigned long count)
| constructor
void | determineMinMax (T minvalue=0, T maxvalue=0, const int mode=0x1)
| determine minimum and maximum pixel values
Protected Member Functions inherited from DiMonoPixel
| DiMonoPixel (const DiPixel *pixel, DiMonoModality *modality)
| constructor
| DiMonoPixel (const DiMonoPixel *pixel, const unsigned long count)
| constructor

## Protected Attributes
T * | Data
| pointer to pixel data
Protected Attributes inherited from DiMonoPixel
DiMonoModality * | Modality
| pointer to modality transform object
Protected Attributes inherited from DiPixel
unsigned long | Count
| number of pixels
unsigned long | InputCount
| number of pixels in the input buffer

## Private Attributes
T | MinValue [2]
| minimum pixel values (0 = global, 1 = ignoring global)
T | MaxValue [2]
| maximum pixel values

## Detailed Description

template<class T>
class DiMonoPixelTemplate< T >

Template class to handle monochrome pixel data.

## Constructor & Destructor Documentation

## ◆ DiMonoPixelTemplate() [1/5]

template<class T>

DiMonoPixelTemplate< T >::DiMonoPixelTemplate | ( | const unsigned long | count | ) |
| inline

constructor

Parameters

  count | number of pixels

References DiMonoPixel::DiMonoPixel(), DiPixel::Count, Data, MaxValue, and MinValue.

Referenced by DiColorMonoTemplate< T >::DiColorMonoTemplate(), DiMonoCopyTemplate< T >::DiMonoCopyTemplate(), DiMonoFlipTemplate< T >::DiMonoFlipTemplate(), DiMonoRotateTemplate< T >::DiMonoRotateTemplate(), and DiMonoScaleTemplate< T >::DiMonoScaleTemplate().

## ◆ DiMonoPixelTemplate() [2/5]

template<class T>

DiMonoPixelTemplate< T >::DiMonoPixelTemplate | ( | const DiInputPixel * | pixel,
|  | DiMonoModality * | modality )
| inline

constructor

Parameters

  pixel | pointer to input pixel data
  modality | pointer to object managing modality transform

References DiMonoPixel::DiMonoPixel(), Data, MaxValue, and MinValue.

## ◆ DiMonoPixelTemplate() [3/5]

template<class T>

DiMonoPixelTemplate< T >::DiMonoPixelTemplate | ( | DiMonoOutputPixel * | pixel,
|  | DiMonoModality * | modality )
| inline

constructor

Parameters

  pixel | pointer to output pixel data used for intermediate representation
  modality | pointer to object managing modality transform

References DiMonoPixel::DiMonoPixel(), Data, getDataPtr(), MaxValue, and MinValue.

## ◆ DiMonoPixelTemplate() [4/5]

template<class T>

DiMonoPixelTemplate< T >::DiMonoPixelTemplate | ( | const DiPixel * | pixel,
|  | DiMonoModality * | modality )
| inlineprotected

constructor

Parameters

  pixel | pointer to intermediate pixel data (not necessarily monochrome)
  modality | pointer to object managing modality transform

References DiMonoPixel::DiMonoPixel(), DiPixel::DiPixel(), Data, MaxValue, and MinValue.

## ◆ DiMonoPixelTemplate() [5/5]

template<class T>

DiMonoPixelTemplate< T >::DiMonoPixelTemplate | ( | const DiMonoPixel * | pixel,
|  | const unsigned long | count )
| inlineprotected

constructor

Parameters

  pixel | pointer to intermediate monochrome pixel data
  count | number of pixels

References DiMonoPixel::DiMonoPixel(), Data, MaxValue, and MinValue.

## Member Function Documentation

## ◆ determineMinMax()

template<class T>

void DiMonoPixelTemplate< T >::determineMinMax | ( | T | minvalue = 0,
|  | T | maxvalue = 0,
|  | const int | mode = 0x1 )
| inlineprotected

determine minimum and maximum pixel values

Parameters

  minvalue | starting global minimum value (0 = invalid)
  maxvalue | starting global maximum value (0 = invalid)
  mode | calculate global min/max if 0x1 bit is set (default), calculate next min/max if 0x2 bit is set

References DiPixel::Count, Data, MaxValue, and MinValue.

Referenced by getMinMaxWindow().

## ◆ getData()

template<class T>

const void * DiMonoPixelTemplate< T >::getData | ( |  | ) | const
| inlinevirtual

get pointer to internal pixel data

Returns
  pointer to pixel data

Implements DiPixel.

References Data.

## ◆ getDataArrayPtr()

template<class T>

void * DiMonoPixelTemplate< T >::getDataArrayPtr | ( |  | ) |
| inlinevirtual

get reference to pointer to internal pixel data.

The returned array points to the (single) image plane. The behaviour of this method is, therefore, identical for both monochrome and color images.

Returns
  reference to pointer to pixel data

Implements DiPixel.

References Data.

## ◆ getDataPtr()

template<class T>

void * DiMonoPixelTemplate< T >::getDataPtr | ( |  | ) |
| inlinevirtual

get pointer to internal pixel data

Returns
  pointer to pixel data

Implements DiPixel.

References Data.

Referenced by DiMonoPixelTemplate().

## ◆ getHistogramWindow()

template<class T>

int DiMonoPixelTemplate< T >::getHistogramWindow | ( | const double | thresh,
|  | double & | center,
|  | double & | width )
| inlinevirtual

get automatically computed histogram window

Parameters

  thresh | ignore certain percentage of pixels at lower and upper boundaries
  center | reference to storage area for window center value
  width | reference to storage area for window width value

Returns
  status, true if successful, false otherwise

Implements DiMonoPixel.

References DiPixel::Count, Data, MaxValue, MinValue, and OFBitmanipTemplate< T >::zeroMem().

## ◆ getMinMaxValues()

template<class T>

int DiMonoPixelTemplate< T >::getMinMaxValues | ( | double & | min,
|  | double & | max ) const
| inlinevirtual

get minimum and maximum pixel values

Parameters

  min | reference to storage area for minimum pixel value
  max | reference to storage area for maximum pixel value

Returns
  status, true if successful, false otherwise

Implements DiMonoPixel.

References MaxValue, and MinValue.

## ◆ getMinMaxWindow()

template<class T>

int DiMonoPixelTemplate< T >::getMinMaxWindow | ( | const int | idx,
|  | double & | center,
|  | double & | width )
| inlinevirtual

get automatically computed min-max window

Parameters

  idx | ignore global min/max pixel values if > 0
  center | reference to storage area for window center value
  width | reference to storage area for window width value

Returns
  status, true if successful, false otherwise

Implements DiMonoPixel.

References determineMinMax(), MaxValue, and MinValue.

## ◆ getRepresentation()

template<class T>

EP_Representation DiMonoPixelTemplate< T >::getRepresentation | ( |  | ) | const
| inlinevirtual

get integer representation

Returns
  integer representation of the internally stored pixel data

Implements DiPixel.

References DiPixelRepresentationTemplate< T >::getRepresentation().

## ◆ getRoiWindow()

template<class T>

virtual int DiMonoPixelTemplate< T >::getRoiWindow | ( | const unsigned long | left_pos,
|  | const unsigned long | top_pos,
|  | const unsigned long | width,
|  | const unsigned long | height,
|  | const unsigned long | columns,
|  | const unsigned long | rows,
|  | const unsigned long | frame,
|  | double & | voiCenter,
|  | double & | voiWidth )
| inlinevirtual

get automatically computed Region of Interest (ROI) window

Parameters

  left_pos | x-coordinate of the top left-hand corner of the ROI (starting from 0)
  top_pos | y-coordinate of the top left-hand corner of the ROI (starting from 0)
  width | width in pixels of the rectangular ROI (minimum: 1)
  height | height in pixels of the rectangular ROI (minimum: 1)
  columns | number of columns (width) of the associated image
  rows | number of rows (height) of the associated image
  frame | index of the frame to be used for the calculation
  voiCenter | reference to storage area for window center value
  voiWidth | reference to storage area for window width value

Returns
  status, true if successful, false otherwise

Implements DiMonoPixel.

References Data.

The documentation for this class was generated from the following file:

- dcmimgle/include/dcmtk/dcmimgle/dimopxt.h

Generated on Wed Apr 30 2025 for DCMTK Version 3.6.9 by Doxygen 1.13.2